def multishape_conv1d(waveform: Tensor,
    filters: Tensor,
    stride: int,
    padding: int=0,
    as_conv1d: bool=True) -> Tensor:
  _0 = "Input tensor was 2D. Applying the corresponding Decoder to the current output will result in a 3D tensor. This behaviours was introduced to match Conv1D and ConvTranspose1D, please use 3D inputs to avoid it. For example, this can be done with input_tensor.unsqueeze(1)."
  _1 = __torch__.asteroid_filterbanks.enc_dec.batch_packed_1d_conv
  if torch.eq(torch.dim(waveform), 1):
    _3 = torch.unsqueeze(torch.unsqueeze(waveform, 0), 1)
    _4 = torch.conv1d(_3, filters, None, [stride], [padding], [1], 1)
    _2 = torch.squeeze(_4)
  else:
    if torch.eq(torch.dim(waveform), 2):
      torch.warn(_0, 2)
      _6 = torch.conv1d(torch.unsqueeze(waveform, 1), filters, None, [stride], [padding], [1], 1)
      _5 = _6
    else:
      if torch.eq(torch.dim(waveform), 3):
        batch, channels, time_len, = torch.size(waveform)
        if torch.eq(channels, 1):
          _8 = as_conv1d
        else:
          _8 = False
        if _8:
          _10 = torch.conv1d(waveform, filters, None, [stride], [padding], [1], 1)
          _9 = _10
        else:
          _11 = _1(waveform, filters, stride, padding, )
          _9 = _11
        _7 = _9
      else:
        _12 = _1(waveform, filters, stride, padding, )
        _7 = _12
      _5 = _7
    _2 = _5
  return _2
def multishape_conv_transpose1d(spec: Tensor,
    filters: Tensor,
    stride: int=1,
    padding: int=0,
    output_padding: int=0) -> Tensor:
  if torch.eq(torch.dim(spec), 2):
    _14 = torch.conv_transpose1d(torch.unsqueeze(spec, 0), filters, None, [stride], [padding], [output_padding], 1, [1])
    _13 = torch.squeeze(_14)
  else:
    if torch.eq(torch.dim(spec), 3):
      _16 = torch.conv_transpose1d(spec, filters, None, [stride], [padding], [output_padding], 1, [1])
      _15 = _16
    else:
      _17 = torch.slice(torch.size(spec), -2, 9223372036854775807, 1)
      view_as = torch.add([-1], _17)
      out = torch.conv_transpose1d(torch.reshape(spec, view_as), filters, None, [stride], [padding], [output_padding], 1, [1])
      _18 = torch.slice(torch.size(spec), 0, -2, 1)
      _19 = torch.view(out, torch.add(_18, [-1]))
      _15 = _19
    _13 = _15
  return _13
def batch_packed_1d_conv(inp: Tensor,
    filters: Tensor,
    stride: int=1,
    padding: int=0) -> Tensor:
  _20 = torch.view(inp, [-1, 1, (torch.size(inp))[-1]])
  batched_conv = torch.conv1d(_20, filters, None, [stride], [padding], [1], 1)
  _21 = torch.slice(torch.size(inp), 0, -1, 1)
  _22 = torch.slice(torch.size(batched_conv), -2, 9223372036854775807, 1)
  output_shape = torch.add(_21, _22)
  _23 = torch.view(batched_conv, output_shape)
  return _23
